/***************************************************************************
                          SAMport.h  -  description
                             -------------------
    begin                : Mon Apr 16 2001
    copyright            : (C) 2001 by Sam "Criswell" Hart
    email                : criswell@geekcomix.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __SAMPORT_H__
#define __SAMPORT_H__
#include <iostream>
#include <fstream>
#include <string>

//namespace SAMport {
//  const int MAX_CHAR_SZ = 10000;
//}

// Abstract data struct
struct SAMport_Abstract {
  int Num;
  std::string From;
  std::string Content_Type;
  std::string To;
  std::string Subject;
  std::string X_Mailer;
  std::string Sender;
  std::string Reply_To;
  std::string Date;
  std::string Message_Id;
  std::string In_Reply_To;
  std::string MIME_Version;
  std::string FullHeader;
  std::string FullMsg;
};

// Main SAMport superclass
class SAMport
{
  public:
    SAMport();  // Constructor
    virtual ~SAMport(); // Destructor

    virtual void load(char *Filename);
    virtual void save(char *Filename);

    virtual SAMport_Abstract next();
    virtual SAMport_Abstract prev();
    virtual SAMport_Abstract first();
    virtual SAMport_Abstract last();
    virtual SAMport_Abstract jump(int num);
    virtual void close();
};

// Exception structures
struct SAMport_FileAlreadyOpen {
  char *msg;
  SAMport_FileAlreadyOpen(char *_msg) { msg = _msg; }
};

struct SAMport_FileOpenFailed {
  char *msg;
  SAMport_FileOpenFailed(char *_msg) { msg = _msg; }
};

struct SAMport_FileNotOpen {
  char *msg;
  SAMport_FileNotOpen(char *_msg) { msg = _msg; }
};

struct SAMport_OutOfRange {
  char *msg;
  SAMport_OutOfRange(char *_msg) { msg = _msg; }
};

struct SAMport_SourceBoxProblem {
  char *msg;
  SAMport_SourceBoxProblem(char *_msg) { msg = _msg; }
};

//sub-class includes
#include "SAMport_umbox.h"
#include "SAMport_oebox.h"

#endif // __SAMPORT_H__
