/***************************************************************************
                          SAMport_oebox.h  -  description
                             -------------------
    begin                : Wed Apr 18 2001
    copyright            : (C) 2001 by Sam "Criswell" Hart
    email                : criswell@geekcomix.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __SAMport_oebox_H__
#define __SAMport_oebox_H__

#include "SAMport.h"
#include <cstdio>
#include "liboe.h"
#include <string>

class SAMport_oebox: public SAMport
{
  public:
    SAMport_oebox();
    ~SAMport_oebox();

    SAMport_oebox(char *Filename);

    void load(char *Filename);
    void save(char *Filename);

    SAMport_Abstract next();
    SAMport_Abstract prev();
    SAMport_Abstract first();
    SAMport_Abstract last();
    SAMport_Abstract jump(int num);
    void close();
    //extern "C" char *fn;
    //extern "C" FILE *box;
  private:
    std::ifstream fin;
    std::ofstream fout;
    std::string last_from_line;
    char *fname;
    //char *fn; // The MS OE import requires a temp file
    int recnum;
    //FILE *box;
    oe_data *results;
};

/* Do not call these, they are needed for compatibility with liboe! */
extern char fn[1024];
extern FILE *box;
extern "C" void writeit(const char *s, int i); // It also requires a function for liboe

#endif // __SAMport_oebox_H__