/***************************************************************************
                          test_umbox.cpp  -  description
                          Tests the UNIX mbox importing
                             -------------------
    begin                : Thu Apr 19 2001
    copyright            : (C) 2001 by Sam "Criswell" Hart
    email                : criswell@geekcomix.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SAMport.h"

int main(int argc, char *argv[])
{
  SAMport *mytest = new SAMport_umbox();
  SAMport_Abstract test;
  std::string temp, post;
  char *line;
  //char line[25];
  int i, x;
  bool still_inside = true;
  bool display;

  if(argc > 1) {
    for(i = 1; i < argc; i++) {
      if((strcmp (argv[i], "-h") == 0) |
          (strcmp (argv[i], "--help") == 0) |
          (strcmp (argv[i], "-help") == 0)) {
        cout << "test_umbox : Simple SAMport UNIX mbox test\n\n"
          << "Command line options\n"
          << "\t-h | -help | --help\tDisplay this help message\n"
          << "\t-file=FNAME\t\tLoad the mbox FNAME\n\n"
          << "Command prompt options\n"
          << "\tload=FNAME\t\tLoad the mbox FNAME\n"
          << "\tnext\t\tShow next record\n"
          << "\tprev\t\tShow prev record\n"
          << "\tfirst\t\tShow first record\n"
          << "\tlast\t\tShow last record\n"
          << "\tjump=NUM\t\tJump to and show record number NUM\n\n"
          << "\tquit | exit\tExit the program\n\n";
      }
      if(strstr(argv[i], "-file")) {
        temp = argv[i];
        x = temp.find("=");
        post = temp.substr((x+1), (temp.length() - x));
        line = (char *)post.c_str();
        try {
          mytest->load(line);
        } catch(SAMport_FileOpenFailed errguy) {
          cerr << "File open failed: " << errguy.msg << "\n";
        }
      }
    }
  }

  do {
    cout << "TEST> ";
    cin >> temp;
    display = false;

    if((int)temp.find("load") > -1) {
      x = temp.find("=");
      post = temp.substr((x+1), (temp.length() - x));
      mytest->close();
      line = (char *)post.c_str();
      try {
        mytest->load(line);
      } catch(SAMport_FileAlreadyOpen errguy) {
        cerr << "File already open caught\n" << errguy.msg << "\n";
      } catch(SAMport_FileOpenFailed errguy) {
        cerr << "File open failed caught\n" << errguy.msg << "\n";
      }
    } else if((int)temp.find("next") > -1) {
      try {
        test = mytest->next();
        display = true;
      } catch(SAMport_FileNotOpen errguy) {
        cerr << "File not open caught\n" << errguy.msg << "\n";
        display = false;
      }
    } else if((int)temp.find("prev") > -1) {
      try {
        test = mytest->prev();
        display = true;
      } catch(SAMport_FileNotOpen errguy) {
        cerr << "File not open caught\n" << errguy.msg << "\n";
        display = false;
      }
    } else if((int)temp.find("first") > -1) {
      try {
        test = mytest->first();
        display = true;
      } catch(SAMport_FileNotOpen errguy) {
        cerr << "File not open caught\n" << errguy.msg << "\n";
        display = false;
      }
    } else if((int)temp.find("last") > -1) {
      try {
        test = mytest->last();
        display = true;
      } catch(SAMport_FileNotOpen errguy) {
        cerr << "File not open caught\n" << errguy.msg << "\n";
        display = false;
      }
    } else if(((int)temp.find("quit") > -1) | ((int)temp.find("end") > -1)) {
      still_inside = false;
    }

    if(display) {
      cout << "Record Num: " << test.Num << "\n"
           << "Message ID: " << test.Message_Id << "\n"
           << "To: " << test.To << "\n"
           << "From: " << test.From << "\n"
           << "Subject: " << test.Subject << "\n"
           << "Date: " << test.Date << "\n"
           << "------------------------------------------\n"
           << test.FullMsg << "\n\n";
    }
  } while (still_inside);
  return 1;
}